﻿using System;
using System.Text;
using GCHR.Model.Konto;

namespace GCHR.Model.Mandant
{
    class Ford : IMandant
    {
        public string BalanceBody(HaendlerKonto konto)
        {
            return KontonummerFormatieren(konto).PadRight(20, ' ') + String.Format("{0,18:0.00}", (konto.Summe)).Replace(',', '.');
        }

        public string AccountsBody(HaendlerKonto konto)
        {
            return KontonummerFormatieren(konto).PadRight(42, ' ') + konto.Bezeichnung;
        }



        protected Konfiguration Config = Konfiguration.GetInstance();

        public bool BalanceDatei
        {
            get
            {
                return true;
            }
        }

        public bool AccountsDatei
        {
            get
            {
                return true;
            }
        }

        public string BalanceHeader
        {
            get
            {
                return String.Format("AA{0} {1}{2} .20EUR", Config.HaendlernummerBmCode, Config.AktuellePeriode.Monat, Config.AktuellePeriode.JahrZweistellig);
            }
        }

        public string BalanceFooter
        {
            get
            {
                return String.Format("XX{0} {1}{2}", Config.HaendlernummerBmCode, Config.AktuellePeriode.Monat, Config.AktuellePeriode.JahrZweistellig);
            }

        }

        public string AccountsHeader
        {
            get
            {
                return "Account Code".PadRight(42, ' ') + "Description";
            }
        }

        public string AccountsFooter
        {
            get
            {
                return String.Empty;
            }

        }

        public string KontonummerFormatieren(HaendlerKonto konto)
        {
            /* Manuelle Konten nur bei Ford Österreich, dann aber ohne Department!
            if (konto.KontoTyp == KontoTypen.ManStat)
            {
                return konto.ToString().PadLeft(Config.HerstellerKontenrahmenStellen, '0');
            } 
             */   
            return konto.Kontonummer.PadLeft(Config.HerstellerKontenrahmenStellen, '0');
        }

        public Encoding Encoding
        {
            get { return Encoding.Default; }
        }
    }
}
