﻿using System;
using System.Text;
using GCHR.Model.Konto;

namespace GCHR.Model.Mandant
{
    class Honda : IMandant
    {
        protected Konfiguration Config = Konfiguration.GetInstance();

        public bool BalanceDatei
        {
            get
            {
                return true;
            }
        }

        public bool AccountsDatei
        {
            get
            {
                return false;
            }
        }

        public string BalanceHeader
        {
            get
            {
                return
                    string.Format(
                        "{1};Dealernumber{0};Honda Germany{0}{2};Evaluation;{3}{0}{4};Fiscal-Year;{5}{0};Timestamp;{6}",
                        Environment.NewLine, Config.HaendlernummerBmCode, Config.AktuellePeriode.Jahr,
                        Config.AktuellePeriode.Monat,
                        Config.AktuellePeriode.Jahresbeginn.Jahr,
                        Config.AktuellePeriode.Jahresbeginn.Monat,
                        DateTime.Now.ToString("MMddyyyy;HHmmss"));
            }
        }

        public string BalanceFooter
        {
            get
            {
                return string.Empty;
            }

        }

        public string BalanceBody(HaendlerKonto konto)
        {
            return (string.Format("{0};{1};{2};{3}", KontonummerFormatieren(konto), konto.Bezeichnung, konto.SummeAktuellePeriode, konto.Summe).Replace(',', '.'));
        }

        public string AccountsHeader
        {
            get
            {
                return string.Empty;
            }
        }

        public string AccountsFooter
        {
            get
            {
                return string.Empty;
            }

        }

        public string KontonummerFormatieren(HaendlerKonto konto)
        {
            return konto.Kontonummer.Substring(0, 4) + konto.Marke + konto.Betrieb + konto.Kontonummer.Substring(4);
        }

        public Encoding Encoding
        {
            get { return Encoding.Default; }
        }

        public string AccountsBody(HaendlerKonto konto)
        {
            return string.Empty;
        }
    }
}
