﻿using System;
using System.Text;
using GCHR.Model.Konto;

namespace GCHR.Model.Mandant
{
    class Landrover : IMandant
    {
        protected Konfiguration Config = Konfiguration.GetInstance();

        public bool BalanceDatei
        {
            get
            {
                return true;
            }
        }

        public bool AccountsDatei
        {
            get
            {
                return false;
            }
        }

        public string BalanceHeader
        {
            get
            {
                return String.Format("{0};{1};{2}", Config.HaendlernummerBmCode, Config.AktuellePeriode.Monat, Config.AktuellePeriode.Jahr);
            }
        }

        public string BalanceFooter
        {
            get { return String.Empty; }

        }

        public string BalanceBody(HaendlerKonto konto)
        {
            return KontonummerFormatieren(konto) + ";" + String.Format("{0:0.00}", konto.Summe) + ";" + konto.Bezeichnung.Replace(';', ',');
        }


        public string AccountsHeader
        {
            get
            {
                return String.Empty;
            }
        }

        public string AccountsBody(HaendlerKonto konto)
        {
            return String.Empty;
        }

        public string AccountsFooter
        {
            get
            {
                return String.Empty;
            }

        }

        public string KontonummerFormatieren(HaendlerKonto konto)
        {
            return konto.Kontonummer + "_" + konto.Marke + konto.Betrieb;
        }

        public Encoding Encoding
        {
            get { return Encoding.GetEncoding(858); }
        }
    }
}
