﻿using System;
using System.Text;
using GCHR.Model.Konto;

namespace GCHR.Model.Mandant
{
    class Volvo : IMandant
    {
        protected Konfiguration Config = Konfiguration.GetInstance();

        public bool BalanceDatei
        {
            get
            {
                return true;
            }
        }

        public bool AccountsDatei
        {
            get
            {
                return true;
            }
        }

        public string BalanceHeader
        {
            get
            {
                return String.Format("AA{0}F{1}{2} .20EUR", Config.HaendlernummerBmCode, Config.AktuellePeriode.Monat, Config.AktuellePeriode.JahrZweistellig);
            }
        }

        public string BalanceFooter
        {
            get
            {
                return String.Format("XX{0}F{1}{2}", Config.HaendlernummerBmCode, Config.AktuellePeriode.Monat, Config.AktuellePeriode.JahrZweistellig);
            }

        }

        public string BalanceBody(HaendlerKonto konto)
        {
            return (KontonummerFormatieren(konto).PadRight(23, ' ') + String.Format("{0,18:0.00}", (konto.Summe)).Replace(',', '.'));
        }


        public string AccountsHeader
        {
            get
            {
                return "Account Code".PadRight(42, ' ') + "Description";
            }
        }
        
        public string AccountsBody(HaendlerKonto konto)
        {
            return (KontonummerFormatieren(konto).PadRight(42, ' ') + konto.Bezeichnung);
        }

        public string AccountsFooter
        {
            get
            {
                return String.Empty;
            }

        }

        public string KontonummerFormatieren(HaendlerKonto konto)
        {
            return konto.Marke + konto.Betrieb + konto.Kontonummer;
        }

        public Encoding Encoding
        {
            get { return Encoding.Default; }
        }
    }
}
