﻿using System.Collections.Generic;
using System.IO;

namespace GCHR.Model.Uebersetzung
{
    class HerstellerKontenrahmen
    {
        private readonly Dictionary<string, HerstellerKonto> _kontenrahmen = new Dictionary<string, HerstellerKonto>();

        public HerstellerKontenrahmen(StreamReader sr)
        {
            while (!sr.EndOfStream)
            {
                var kto = new HerstellerKonto(sr.ReadLine());
                while (_kontenrahmen.ContainsKey(kto.Kontonummer))
                {
                    kto.Kontonummer += "X";
                }
                _kontenrahmen.Add(kto.Kontonummer, kto);
            }
        }

        public void Speichern(StreamWriter sw)
        {
            foreach (var kto in _kontenrahmen.Values)
            {
                sw.WriteLine(kto);
            }
        }

        public bool Contains(string kontonummer)
        {
            return _kontenrahmen.ContainsKey(kontonummer);
        }

        public HerstellerKonto Get(string kontonummer)
        {
            return _kontenrahmen[kontonummer];
        }



    }
}
