﻿using System;
using System.Linq;

namespace GCHR.Model.Uebersetzung
{
    class Regel
    {
        internal static string Hauptmarke = "1";
        internal static string Hauptbetrieb = "01";

        public Regel(string regel)
        {
            if (regel == "")
            {
                _markeDefault = Hauptmarke;
                _betriebDefault = Hauptbetrieb;
                return;
            }
            var split = regel.Split(new char[] { ',' });

            var markeSplit = split[0].Split(new char[] { ':' });
            _markeRegel = (markeSplit[0] != "") ? markeSplit[0] : "0";
            _markeDefault = (markeSplit.Count() > 1) ? markeSplit[1] : Hauptmarke;

            if (split.Count() > 1)
            {
                var betriebSplit = split[1].Split(new char[] { ':' });
                _betriebRegel = (betriebSplit[0] != "") ? betriebSplit[0] : "0";
                _betriebDefault = (betriebSplit.Count() > 1) ? betriebSplit[1] : Hauptbetrieb;
            }
        }

        private readonly string _markeRegel = "0";
        private readonly string _markeDefault;
        private readonly string _betriebRegel = "0";
        private readonly string _betriebDefault;

        public override string ToString()
        {
            return String.Format("{0}:{1},{2}:{3}", _markeRegel, _markeDefault, _betriebRegel, _betriebDefault);
        }
    }
}
